diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index e6df39416..24b6aacf5 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -1,6 +1,20 @@
 package net.minecraft.client;
 
+import static net.minecraft.core.Global.*;
+import static org.lwjgl.opengl.GL11.*;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Random;
+
+import org.lwjgl.LWJGLException;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.Display;
+
 import com.mojang.nbt.CompoundTag;
+
 import net.minecraft.client.achievement.stat.StatStringFormatKeyInv;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.entity.ClientSkinVariantList;
@@ -48,6 +62,7 @@ import net.minecraft.client.player.controller.PlayerController;
 import net.minecraft.client.render.ChunkRenderer;
 import net.minecraft.client.render.EffectRenderer;
 import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.FallbackRenderer;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.LightmapHelper;
@@ -62,9 +77,7 @@ import net.minecraft.client.render.WorldRenderer;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.camera.EntityCameraFirstPerson;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.colorizer.ColorizerFoliage;
-import net.minecraft.client.render.colorizer.ColorizerGrass;
-import net.minecraft.client.render.colorizer.ColorizerWater;
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.shader.Shaders;
@@ -129,35 +142,6 @@ import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
-import org.lwjgl.LWJGLException;
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.Display;
-
-import java.io.File;
-import java.io.IOException;
-import java.util.ArrayList;
-import java.util.Random;
-
-import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
-import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.glAlphaFunc;
-import static org.lwjgl.opengl.GL11.glBindTexture;
-import static org.lwjgl.opengl.GL11.glClear;
-import static org.lwjgl.opengl.GL11.glClearColor;
-import static org.lwjgl.opengl.GL11.glClearDepth;
-import static org.lwjgl.opengl.GL11.glColor4f;
-import static org.lwjgl.opengl.GL11.glCullFace;
-import static org.lwjgl.opengl.GL11.glDepthFunc;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-import static org.lwjgl.opengl.GL11.glLoadIdentity;
-import static org.lwjgl.opengl.GL11.glMatrixMode;
-import static org.lwjgl.opengl.GL11.glOrtho;
-import static org.lwjgl.opengl.GL11.glShadeModel;
-import static org.lwjgl.opengl.GL11.glTranslatef;
-import static org.lwjgl.opengl.GL11.glViewport;
 
 // Referenced classes of package net.minecraft.client:
 //            MinecraftApplet
@@ -226,7 +210,7 @@ public class Minecraft
     public final GameResolution resolution = new GameResolution(this);
     public final ClientCommandHandler commandHandler = new ClientCommandHandler(this);
     public boolean fullbright = false;
-    public Renderer render;
+    public Renderer renderer;
     public ControllerInput controllerInput;
     public final MouseInput mouseInput = new MouseInput(this);
     public InputType inputType = InputType.KEYBOARD;
@@ -381,7 +365,7 @@ public class Minecraft
         if(Shaders.enableShaders) {
             setRenderer(new ShadersRenderer(this));
         }else {
-            setRenderer(new Renderer(this));
+            setRenderer(new FallbackRenderer(this));
         }
 
         texturePackList = new TexturePackList(this, mcDataDir);
@@ -394,15 +378,7 @@ public class Minecraft
         
         // Initialize overworld biome map
         BiomeProviderOverworld.init();
-
-        ColorizerWater.updateColorData(renderEngine.getTextureImageData("/misc/watercolor.png"));
-        ColorizerGrass.defaultColor.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor.png"));
-        ColorizerGrass.spring.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor_spring.png"));
-        ColorizerGrass.summer.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor.png"));
-        ColorizerGrass.fall.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor_fall.png"));
-        ColorizerGrass.winter.updateColorData(renderEngine.getTextureImageData("/misc/grasscolor_winter.png"));
-        ColorizerFoliage.updateColorData(renderEngine.getTextureImageData("/misc/foliagecolor.png"));
-
+        
         worldRenderer = new WorldRenderer(this);
 
         // I hate initialization issues so much
@@ -453,6 +429,8 @@ public class Minecraft
         
         loadScreen();	// Update loading screen so it doesn't say no response
         
+        Colorizers.init(this);
+        
         renderEngine.refreshTextures(new ArrayList<>());
 
         loadScreen();	// Update loading screen so it doesn't say no response
@@ -891,7 +869,7 @@ public class Minecraft
                     Debug.change("render"); // 2
                     Debug.push("post"); // 3
                     
-                    render.beginRenderGame(timer.partialTicks);
+                    renderer.beginRenderGame(timer.partialTicks);
                     glEnable(GL_ALPHA_TEST);
 
                     Debug.change("misc");  // 3
@@ -917,7 +895,7 @@ public class Minecraft
                     guiAchievement.updateAchievementWindow();
 
                     Debug.change("post");  // 3
-                    render.endRenderGame(timer.partialTicks);
+                    renderer.endRenderGame(timer.partialTicks);
                     
                     Debug.pop();	// 3
                     
@@ -1220,9 +1198,6 @@ public class Minecraft
                 chunkproviderloadorgenerate.setCurrentChunkOver(playerChunkX, playerChunkZ);
             }
         }
-        if(theWorld != null) {
-        	theWorld.updateAllOnLightChange = !LightmapHelper.isLightmapEnabled();
-        }
         if(!isGamePaused && theWorld != null)
         {
             playerController.tick();
@@ -1492,7 +1467,7 @@ public class Minecraft
                             displayInGameMenu();
                         }
                         else if (Keyboard.getEventKey() == Keyboard.KEY_F7) {
-                            render.reload();
+                            renderer.reload();
                         }
                         else if (gameSettings.keyCommand.isPressed())
                         {
@@ -1913,7 +1888,7 @@ public class Minecraft
         sndManager.loadSoundSettings(gameSettings);
         downloadResourcesThread.reloadResources();
         renderEngine.refreshTexturesAndDisplayErrors();
-        render.reload();
+        renderer.reload();
         if (renderGlobal != null){
             renderGlobal.loadRenderers();
         }
@@ -2101,6 +2076,7 @@ public class Minecraft
             loadingScreen.progressStop();
         }
         worldRenderer.lightmapHelper.setup();
+        Colorizers.update(true);
     }
 
     private void convertSaveVersion(int fromVersion, String worldDirName, String worldName)
@@ -2324,11 +2300,11 @@ public class Minecraft
     }
     
     public void setRenderer(Renderer renderer) {
-        if(this.render != null) {
-            this.render.delete();
+        if(this.renderer != null) {
+            this.renderer.delete();
         }
-        this.render = renderer;
-        this.render.reload();
+        this.renderer = renderer;
+        this.renderer.reload();
     }
 
     public static void startMainThread(String username, String sessionId)
diff --git a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index fb3fe72ac..16e748cea 100644
--- a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -39,7 +39,6 @@ public class RichPresenceHandlerThread extends Thread
         biomeNamesMap.put(Biomes.OVERWORLD_SWAMPLAND, "the swamplands");
         biomeNamesMap.put(Biomes.OVERWORLD_SEASONAL_FOREST, "a seasonal forest");
         biomeNamesMap.put(Biomes.OVERWORLD_FOREST, "a forest");
-        biomeNamesMap.put(Biomes.OVERWORLD_FOREST_DRY, "a dry forest");
         biomeNamesMap.put(Biomes.OVERWORLD_GRASSLANDS, "the grasslands");
         biomeNamesMap.put(Biomes.OVERWORLD_OUTBACK, "the outback");
         biomeNamesMap.put(Biomes.OVERWORLD_SHRUBLAND, "a shrubland");
diff --git a/src/main/java/net/minecraft/client/gui/GuiIngame.java b/src/main/java/net/minecraft/client/gui/GuiIngame.java
index 97d4ea9c2..ab4d71d30 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngame.java
+++ b/src/main/java/net/minecraft/client/gui/GuiIngame.java
@@ -1,5 +1,17 @@
 package net.minecraft.client.gui;
 
+import static net.minecraft.core.util.helper.Utils.*;
+import static org.lwjgl.opengl.GL11.*;
+
+import java.awt.Color;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.opengl.GL11;
+
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.EntityClientPlayerMP;
 import net.minecraft.client.gui.hud.HudComponent;
@@ -20,7 +32,6 @@ import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.ChatLine;
@@ -32,29 +43,6 @@ import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.wind.WindManager;
 
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
-
-import java.awt.*;
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-
-import static net.minecraft.core.util.helper.Utils.floor10;
-import static net.minecraft.core.util.helper.Utils.floor100;
-import static net.minecraft.core.util.helper.Utils.percentRound;
-import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
-import static org.lwjgl.opengl.GL11.GL_BLEND;
-import static org.lwjgl.opengl.GL11.GL_LIGHTING;
-import static org.lwjgl.opengl.GL11.GL_ONE_MINUS_SRC_ALPHA;
-import static org.lwjgl.opengl.GL11.GL_SRC_ALPHA;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.glBlendFunc;
-import static org.lwjgl.opengl.GL11.glColor4d;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-
 public class GuiIngame extends Gui
 {
 
@@ -214,7 +202,7 @@ public class GuiIngame extends Gui
                 drawDebugScreenLineRight(GL11.glGetString(GL11.GL_RENDERER));
                 drawDebugScreenLineRight(GL11.glGetString(GL11.GL_VERSION));
                 drawDebugScreenLineRight("Resolution: " + mc.resolution.width + "x" + mc.resolution.height);
-                drawDebugScreenLineRight("Render Resolution: " + mc.render.renderWidth + "x" + mc.render.renderHeight);
+                drawDebugScreenLineRight("Render Resolution: " + mc.renderer.getRenderWidth() + "x" + mc.renderer.getRenderHeight());
                 drawDebugScreenLine("Better than Adventure! " + Minecraft.VERSION);
                 drawDebugScreenLine(mc.debug);
                 drawDebugScreenLine(mc.getRendererDebugInfo());
diff --git a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
index aa7c17200..b79326202 100644
--- a/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
+++ b/src/main/java/net/minecraft/client/gui/GuiPhotoMode.java
@@ -83,8 +83,8 @@ public class GuiPhotoMode extends GuiScreen
             photoModeRenderer = new PhotoModeRenderer(mc, this);
         }
         
-        this.previousRenderer = mc.render;
-        mc.renderGlobal.allChanged();
+        this.previousRenderer = mc.renderer;
+        mc.theWorld.updateSeasonAndLight();
         originalTOD = mc.theWorld.getWorldTime();
     }
 
@@ -198,7 +198,7 @@ public class GuiPhotoMode extends GuiScreen
             mc.setRenderer(previousRenderer);
         }
 
-        mc.renderGlobal.allChanged();
+        mc.theWorld.updateSeasonAndLight();
     }
 
     @Override
@@ -229,7 +229,7 @@ public class GuiPhotoMode extends GuiScreen
             }
 
             mc.theWorld.setWorldTimeUpdateTicks(desiredDay + desiredTOD);
-            mc.theWorld.doSeasonUpdate(true);
+            mc.theWorld.updateSeasonAndLight();
         }
         else if (button == buttonTakeScreenshot)
         {
@@ -396,7 +396,7 @@ public class GuiPhotoMode extends GuiScreen
             }
 
             mc.theWorld.setWorldTimeUpdateTicks(desiredDay + desiredTOD);
-            mc.theWorld.doLightingUpdate();
+            mc.theWorld.updateSeasonAndLight();
 
             updateButtonsText();
         }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
index b36113763..aa2cec406 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
@@ -88,7 +88,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
             photoModeRenderer = new PhotoModeRenderer(mc, this);
         }
 
-        this.previousRenderer = mc.render;
+        this.previousRenderer = mc.renderer;
         showPlayer = false;
         showHelpText = false;
         lastIZoom = iZoom = iZoomGoal = 8.5f;
@@ -449,7 +449,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         try {
             File screenshotsDir = new File(mc.getMinecraftDir(), "screenshots");
             screenshotsDir.mkdir();
-            Texture texture = ((ShadersRenderer)mc.render).getWorldFramebufferTex();
+            Texture texture = ((ShadersRenderer)mc.renderer).getWorldFramebufferTex();
             texture.bind();
 
             int w = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
diff --git a/src/main/java/net/minecraft/client/render/FallbackRenderer.java b/src/main/java/net/minecraft/client/render/FallbackRenderer.java
new file mode 100644
index 000000000..0c1a3789e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/FallbackRenderer.java
@@ -0,0 +1,58 @@
+package net.minecraft.client.render;
+
+import net.minecraft.client.Minecraft;
+
+public class FallbackRenderer implements Renderer {
+
+	public Minecraft mc;
+	
+	public FallbackRenderer(Minecraft minecraft) {
+		mc = minecraft;
+	}
+	
+	@Override
+	public void beginRenderGame(float partialTicks) {
+		
+	}
+
+	@Override
+	public void endRenderGame(float partialTicks) {
+		
+	}
+
+	@Override
+	public void beginRenderWorld(float partialTicks) {
+		
+	}
+
+	@Override
+	public void endRenderWorld(float partialTicks) {
+		
+	}
+
+	@Override
+	public void reload() {
+		
+	}
+
+	@Override
+	public void delete() {
+		
+	}
+
+	@Override
+	public void create() {
+		
+	}
+
+	@Override
+	public int getRenderWidth() {
+		return mc.resolution.width;
+	}
+
+	@Override
+	public int getRenderHeight() {
+		return mc.resolution.height;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index 20408bc83..3e46d7808 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -12,9 +12,8 @@ import net.minecraft.client.gui.GuiPhotoMode;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.render.camera.CameraUtil;
-import net.minecraft.client.render.colorizer.ColorizerWater;
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.Dimension;
@@ -117,7 +116,7 @@ public class FogManager {
         float gSky = (float)skyColor.yCoord;
         float bSky = (float)skyColor.zCoord;
 
-        Vec3d worldColor = world.getFogColor(mc.thePlayer.x, mc.thePlayer.y, mc.thePlayer.z, partialTick);
+        Vec3d worldColor = world.getFogColor(mc.activeCamera, partialTick);
         fogRed = (float)worldColor.xCoord;
         fogGreen = (float)worldColor.yCoord;
         fogBlue = (float)worldColor.zCoord;
@@ -144,8 +143,8 @@ public class FogManager {
                 int z = MathHelper.floor_double(mc.activeCamera.getZ(partialTick));
                 double temp = world.getBlockTemperature(x, z);
                 double humid = world.getBlockHumidity(x, z);
-                int waterColor = ColorizerWater.getWaterColor(temp, humid);
-
+                int waterColor = Colorizers.water.getColor(temp, humid);
+                
                 float red = ((waterColor >> 16) & 0xFF) / 255F;
                 float green = ((waterColor >> 8) & 0xFF) / 255F;
                 float blue = (waterColor & 0xFF) / 255F;
diff --git a/src/main/java/net/minecraft/client/render/Framebuffer.java b/src/main/java/net/minecraft/client/render/Framebuffer.java
index 342c80e56..597e1ea88 100644
--- a/src/main/java/net/minecraft/client/render/Framebuffer.java
+++ b/src/main/java/net/minecraft/client/render/Framebuffer.java
@@ -2,39 +2,45 @@ package net.minecraft.client.render;
 
 import static org.lwjgl.opengl.ARBFramebufferObject.*;
 
-public class Framebuffer extends GLObject<Framebuffer>{
+public class Framebuffer {
 	
 	private int id;
 	
-	public Framebuffer generate() {
+	public boolean generate() {
 		if(isGenerated()) {
-			delete();
+			return false;
 		}
+		
 		this.id = glGenFramebuffers();
-		if(this.id == 0) throw new RuntimeException("Framebuffer not created!");
-		return this;
+		if(!isGenerated()) {
+			throw new RuntimeException("Framebuffer not created!");
+		}
+		
+		return true;
 	}
 	
-	public void delete() {
-		if(!isGenerated()) return;
+	public boolean delete() {
+		if(!isGenerated()) {
+			return false;
+		}
+		
 		glDeleteFramebuffers(id);
 		id = 0;
+		return true;
 	}
 	
-	@Override
-	public Framebuffer bind() {
-		if(!isGenerated()) throw new NullPointerException();
+	public boolean bind() {
+		if(!isGenerated()) {
+			return false;
+		}
 		glBindFramebuffer(GL_FRAMEBUFFER, id);
-		return this;
+		return true;
 	}
 	
-	@Override
-	public Framebuffer unbind() {
+	public void unbind() {
 		glBindFramebuffer(GL_FRAMEBUFFER, 0);
-		return this;
 	}
 	
-	@Override
 	public boolean isGenerated() {
 		return id != 0;
 	}
diff --git a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index e3ef32389..f9a5adeb0 100644
--- a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -158,7 +158,7 @@ public class LoadingScreenRenderer
         }
         startTime = time;
 
-        minecraft.render.beginRenderGame(1.0f);
+        minecraft.renderer.beginRenderGame(1.0f);
     	glEnable(GL_ALPHA_TEST);
 
         // Set up background
@@ -215,7 +215,7 @@ public class LoadingScreenRenderer
         // Draw tip
         minecraft.fontRenderer.drawStringWithShadow(tip, (width - minecraft.fontRenderer.getStringWidth(tip)) / 2, (height / 2 - 4) + 32, 0xffffff);
         
-        minecraft.render.endRenderGame(1.0f);
+        minecraft.renderer.endRenderGame(1.0f);
         
         Display.update();
         try
diff --git a/src/main/java/net/minecraft/client/render/RenderEngine.java b/src/main/java/net/minecraft/client/render/RenderEngine.java
index 30d703bd6..b0eb10ab2 100644
--- a/src/main/java/net/minecraft/client/render/RenderEngine.java
+++ b/src/main/java/net/minecraft/client/render/RenderEngine.java
@@ -1,18 +1,29 @@
 package net.minecraft.client.render;
 
+import static net.minecraft.client.util.helper.Textures.*;
+import static net.minecraft.core.util.helper.Buffer.*;
+import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL12.*;
+
+import java.awt.image.BufferedImage;
+import java.io.InputStream;
+import java.nio.ByteBuffer;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
 import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonElement;
 import com.b100.json.element.JsonObject;
+
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.popup.GuiPopup;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.MipmapType;
-import net.minecraft.client.render.colorizer.ColorProperties;
-import net.minecraft.client.render.colorizer.ColorizerFoliage;
-import net.minecraft.client.render.colorizer.ColorizerGrass;
-import net.minecraft.client.render.colorizer.ColorizerWater;
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.dynamictexture.DynamicTexture;
 import net.minecraft.client.render.dynamictexture.DynamicTextureCalendar;
 import net.minecraft.client.render.dynamictexture.DynamicTextureClock;
@@ -36,43 +47,6 @@ import net.minecraft.client.util.helper.Colors;
 import net.minecraft.client.util.helper.TexturePackJsonHelper;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.Buffer;
-import net.minecraft.core.util.helper.Color;
-import net.minecraft.core.world.season.Seasons;
-
-import java.awt.image.BufferedImage;
-import java.io.IOException;
-import java.io.InputStream;
-import java.nio.ByteBuffer;
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-import java.util.Properties;
-
-import static net.minecraft.client.util.helper.Textures.getImageData;
-import static net.minecraft.client.util.helper.Textures.missingTexture;
-import static net.minecraft.client.util.helper.Textures.readImage;
-import static net.minecraft.client.util.helper.Textures.unwrapImageByColumns;
-import static net.minecraft.core.util.helper.Buffer.buffer;
-import static org.lwjgl.opengl.GL11.GL_CLAMP;
-import static org.lwjgl.opengl.GL11.GL_LINEAR;
-import static org.lwjgl.opengl.GL11.GL_NEAREST;
-import static org.lwjgl.opengl.GL11.GL_NEAREST_MIPMAP_LINEAR;
-import static org.lwjgl.opengl.GL11.GL_REPEAT;
-import static org.lwjgl.opengl.GL11.GL_RGBA;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_MAG_FILTER;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_MIN_FILTER;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_WRAP_S;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_WRAP_T;
-import static org.lwjgl.opengl.GL11.GL_UNSIGNED_BYTE;
-import static org.lwjgl.opengl.GL11.glBindTexture;
-import static org.lwjgl.opengl.GL11.glDeleteTextures;
-import static org.lwjgl.opengl.GL11.glGetTexParameteri;
-import static org.lwjgl.opengl.GL11.glTexImage2D;
-import static org.lwjgl.opengl.GL11.glTexParameteri;
-import static org.lwjgl.opengl.GL11.glTexSubImage2D;
-import static org.lwjgl.opengl.GL12.GL_TEXTURE_MAX_LEVEL;
 
 public class RenderEngine {
 
@@ -739,34 +713,12 @@ public class RenderEngine {
 		Colors.loadColors();
 		
 		mc.fontRenderer = new FontRenderer(gameSettings, "/font/default.png", this);
-
-		// Reload colors
-		Properties colors = new Properties();
-		InputStream stream = null;
-		try {
-			stream = texturePacks.getResourceAsStream("/misc/colors.properties");
-			colors.load(stream);
-		}catch (IOException ignored) {
-			
-		}finally {
-			try {
-				// CLOSE YOUR INPUT STREAMS
-				stream.close();
-			}catch (Exception e) {}
-		}
-		ColorProperties.loadColors(colors);
 		
 		mc.skinVariantList.refresh(errors);
 		mc.mainMenuBackground.refresh(errors);
 		
-        ColorizerWater.updateColorData(mc.renderEngine.getTextureImageData("/misc/watercolor.png"));
-		ColorizerGrass.defaultColor.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor.png"));
-		ColorizerGrass.spring.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor_spring.png"));
-		ColorizerGrass.summer.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor.png"));
-		ColorizerGrass.fall.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor_fall.png"));
-		ColorizerGrass.winter.updateColorData(mc.renderEngine.getTextureImageData("/misc/grasscolor_winter.png"));
-        ColorizerFoliage.updateColorData(mc.renderEngine.getTextureImageData("/misc/foliagecolor.png"));
-        ColorizerGrass.update(true);
+        Colorizers.reload();
+        
         mc.worldRenderer.lightmapHelper.setup();
 	}
 
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index e28a7e0fa..a3cdcfc8b 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -12,6 +12,7 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.BlockModelLeaves;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
@@ -293,7 +294,7 @@ public class RenderGlobal
 
     public void renderAurora(ICamera camera, float partialTick)
     {
-        float celestialAngle = worldObj.getWorldType().getCelestialAngle(worldObj, worldObj.getWorldTime(), partialTick);
+        float celestialAngle = worldObj.getCelestialAngle(partialTick);
         if (celestialAngle < 0.25f) return;
 
         double cameraX = camera.getX(partialTick);
@@ -957,7 +958,7 @@ public class RenderGlobal
         GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/environment/clouds.png"));
         GL11.glEnable(3042 /*GL_BLEND*/);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        Vec3d dimensionColor = worldObj.getDimensionColor(partialTick);
+        Vec3d dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
         float r = (float)dimensionColor.xCoord;
         float g = (float)dimensionColor.yCoord;
         float b = (float)dimensionColor.zCoord;
@@ -1004,7 +1005,7 @@ public class RenderGlobal
             aSun = sunriseColor[3] / 2;
         }
 
-        Vec3d dimensionColor = worldObj.getDimensionColor(partialTick);
+        Vec3d dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
         float rDim = (float)dimensionColor.xCoord;
         float gDim = (float)dimensionColor.yCoord;
         float bDim = (float)dimensionColor.zCoord;
@@ -1631,19 +1632,20 @@ public class RenderGlobal
         }
     }
     
-    @Override
-    public void allChanged()
-    {
-        for (ChunkRenderer chunkRenderer : chunkRenderers)
-        {
-            if (chunkRenderer.isChunkLit && !chunkRenderer.needsUpdate)
-            {
-                chunkRenderersToUpdate.add(chunkRenderer);
-                chunkRenderer.markDirty();
-            }
-        }
-
-    }
+	@Override
+	public void allChanged(boolean lightChanged, boolean seasonChanged) {
+		if(seasonChanged) {
+			Colorizers.update(false);
+		}
+		if(seasonChanged || lightChanged && !LightmapHelper.isLightmapEnabled()) {
+			for(ChunkRenderer chunkRenderer : chunkRenderers) {
+				if(chunkRenderer.isChunkLit && !chunkRenderer.needsUpdate) {
+					chunkRenderersToUpdate.add(chunkRenderer);
+					chunkRenderer.markDirty();
+				}
+			}
+		}
+	}
 
     @Override
     public void tileEntityChanged(int x, int y, int z, TileEntity tileEntity)
diff --git a/src/main/java/net/minecraft/client/render/Renderer.java b/src/main/java/net/minecraft/client/render/Renderer.java
index 555722055..02e90068a 100644
--- a/src/main/java/net/minecraft/client/render/Renderer.java
+++ b/src/main/java/net/minecraft/client/render/Renderer.java
@@ -1,45 +1,23 @@
 package net.minecraft.client.render;
 
-import net.minecraft.client.Minecraft;
-
-public class Renderer {
-	
-	public final Minecraft mc;
+public interface Renderer {
 	
-	public int renderWidth;
-	public int renderHeight;
+	public void beginRenderGame(float partialTicks);
 	
-	public Renderer(Minecraft minecraft) {
-		this.mc = minecraft;
-	}
+	public void endRenderGame(float partialTicks);
 	
-	public void beginRenderGame(float partialTicks) {
-		renderWidth = mc.resolution.width;
-		renderHeight = mc.resolution.height;
-	}
+	public void beginRenderWorld(float partialTicks);
 	
-	public void endRenderGame(float partialTicks) {
-		
-	}
+	public void endRenderWorld(float partialTicks);
 	
-	public void beginRenderWorld(float partialTicks) {
-		
-	}
+	public void reload();
 	
-	public void endRenderWorld(float partialTicks) {
-		
-	}
+	public void delete();
 	
-	public void reload() {
-		
-	}
+	public void create();
 	
-	public void delete() {
-		
-	}
+	public int getRenderWidth();
 	
-	public void create() {
-		
-	}
+	public int getRenderHeight();
 	
 }
diff --git a/src/main/java/net/minecraft/client/render/Texture.java b/src/main/java/net/minecraft/client/render/Texture.java
index dc6afba98..a51d63c8f 100644
--- a/src/main/java/net/minecraft/client/render/Texture.java
+++ b/src/main/java/net/minecraft/client/render/Texture.java
@@ -4,37 +4,45 @@ import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.GLAllocation;
 
-public class Texture extends GLObject<Texture>{
+public class Texture {
 	
 	private int id;
 	
-	public Texture generate() {
-		if(isGenerated()) delete();
+	public boolean generate() {
+		if(isGenerated()) {
+			return false;
+		}
+		
 		id = GLAllocation.generateTexture();
-		if(!isGenerated()) throw new RuntimeException("Texture not created!");
-		return this;
+		if(!isGenerated()) {
+			throw new RuntimeException("Texture not created!");
+		}
+		
+		return true;
 	}
 	
-	@Override
-	public Texture bind() {
-		if(!isGenerated()) throw new NullPointerException();
+	public boolean delete() {
+		if(!isGenerated()) {
+			return false;
+		}
+		GLAllocation.deleteTexture(id);
+		id = 0;
+		return true;
+	}
+	
+	public boolean bind() {
+		if(!isGenerated()) {
+			return false;
+		}
+		
 		glBindTexture(GL_TEXTURE_2D, id);
-		return this;
+		return true;
 	}
 
-	@Override
-	public Texture unbind() {
+	public void unbind() {
 		glBindTexture(GL_TEXTURE_2D, 0);
-		return this;
-	}
-	
-	public void delete() {
-		if(!isGenerated()) return;
-		GLAllocation.deleteTexture(id);
-		id = 0;
 	}
 	
-	@Override
 	public boolean isGenerated() {
 		return id != 0;
 	}
